using FluentNHibernate.Mapping;

namespace Tiger.Game.Achievements;

public class AchievementMap : ClassMap<Achievement>
{
    public AchievementMap()
    {
        Table("achievements");
        LazyLoad();
        Id(a => a.Id).Column("id").GeneratedBy.Identity();
        Map(a => a.Badge).Column("badge").Not.Nullable();
        Map(a => a.Category).Column("category").Not.Nullable();
        HasMany(a => a.Levels).AsMap(al => al.Level).Cascade.All();
    }
}