using Tiger.Game.Achievements;

namespace Tiger.Game.Habbos;

public class HabboAchievement
{
    public virtual Habbo Habbo { get; set; } = null!;
    public virtual Achievement Achievement { get; set; } = null!;
    public virtual int Level { get; set; }
    public virtual int Progress { get; set; }
    
    public override bool Equals(object? obj)
    {
        if (obj is not HabboAchievement other)
            return false;

        return Habbo.Id == other.Habbo.Id && Achievement.Id == other.Achievement.Id;
    }

    public override int GetHashCode()
    {
        unchecked
        {
            var hash = 17;
            hash = hash * 23 + Habbo.Id.GetHashCode();
            hash = hash * 23 + Achievement.Id.GetHashCode();
            return hash;
        }
    }
}